/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */

package ChatProgramm;

import ChatProgramm.controller.GrafikController;
import ChatProgramm.controller.commands.CommandConnectV2;
import ChatProgramm.controller.commands.CommandSendV2;
import ChatProgramm.model.ChatModel;
import ChatProgramm.model.GrafikDaten;
import ChatProgramm.controller.ReceiveAdapter;
import ChatProgramm.view.ChatView;
import ChatProgramm.view.GrafikView;
import javax.swing.JOptionPane;
import javax.swing.UIManager;

/**
 * Builder Class
 * @author le
 */
public class Start
{
  public Start()
  {
    GrafikDaten gDaten = new GrafikDaten();
    ChatView view = new ChatView();
    GrafikView zeichenflaeche = view.getGvZeichenflaeche();
    zeichenflaeche.setModel(gDaten);
    
    ChatModel model = new ChatModel(gDaten);

    GrafikController gContoller = new GrafikController(view,model);
    gContoller.registerEvents();

    CommandConnectV2 cConnect = new CommandConnectV2(view,model);
    cConnect.registerEvents();

    CommandSendV2 cSend = new CommandSendV2(view, model);
    cSend.registerEvents();

    ReceiveAdapter rAdapter = new ReceiveAdapter(view, model);
    model.addSubscription(rAdapter);

    
    view.setVisible(true);
  }

  /**
   * @param args the command line arguments
   */
  public static void main(String[] args) 
  {
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch (Exception ex)
    {
      JOptionPane.showMessageDialog(null, ex.toString());
    }
    new Start();
  }
}