/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package ChatProgramm.model;

import ChatProgramm.util.OhmLogger;

import java.util.concurrent.Flow;
import java.util.concurrent.Flow.Subscriber;
import java.util.concurrent.SubmissionPublisher;
import java.util.logging.Logger;

/**
 * @author Js-Sc
 */
public class ChatModel implements Subscriber<Figur> {

    private static Logger lg = OhmLogger.getLogger();
    private SubmissionPublisher<Figur> figurPublisher;
    private Flow.Subscription subscription;

    private Transmitter transmitter;
    private GrafikDaten grafikDaten;



    public ChatModel(GrafikDaten gDaten) {
        this.grafikDaten = gDaten;
        this.transmitter = null;

        this.figurPublisher = new SubmissionPublisher<>();
    }

    public void setTransmitter(Transmitter transmitter) {
        this.transmitter = transmitter;
        this.transmitter.addSubscription(this);
    }


    public void addSubscription(Subscriber<Figur> subscriber) {
        figurPublisher.subscribe(subscriber);
    }


    @Override
    public void onSubscribe(Flow.Subscription subscription) {
        this.subscription = subscription;
        this.subscription.request(1);
    }

    @Override
    public void onNext(Figur item) {
        grafikDaten.addFigure(item);
        lg.info("Figur wurde dem Grafikmodel hinzugefügt");
        figurPublisher.submit(item);
        this.subscription.request(1);
    }

    @Override
    public void onError(Throwable throwable) {
        throw new UnsupportedOperationException("Not supported yet."); // Generated from nbfs://nbhost/SystemFileSystem/Templates/Classes/Code/GeneratedMethodBody
    }

    @Override
    public void onComplete() {
        throw new UnsupportedOperationException("Not supported yet."); // Generated from nbfs://nbhost/SystemFileSystem/Templates/Classes/Code/GeneratedMethodBody
    }

    public GrafikDaten getGrafikDaten() {
        return grafikDaten;
    }

    public void sendFigur() {
        lg.info("Sende aktuelle Figur");
        transmitter.send(grafikDaten.getFiguren().getLast());
    }

}
